import base64
import json
from google.cloud import firestore

def hello_pubsub(event, context):
    """Triggered from a message on a Cloud Pub/Sub topic.
    Args:
         event (dict): Event payload.
         context (google.cloud.functions.Context): Metadata for the event.
    """
    pubsub_message = base64.b64decode(event['data']).decode('utf-8')
    print(pubsub_message)
    message_json = json.loads(pubsub_message)
    Timestamp = message_json['timestamp']
    IntendID = message_json['intendID']
    ProjectName = message_json['projectName']
    ArtifactName = message_json['artifactName']
    ArtifactVersion = message_json['artifactVersion']
    Environment = message_json['environment']
    RequesterEmail = message_json['requesterEmail']
     
    requestartifact = {
      'timestamp' : Timestamp,
      'intendID' : IntendID,
      'projectName' : ProjectName,
      'artifactName' : ArtifactName,
      'artifactVersion' : ArtifactVersion,
      'environment' : Environment,
      'requesterEmail' : RequesterEmail
   }

    db = firestore.Client()
    update_time, request_artifact = db.collection(u'requestArtifactDeployment').add(requestartifact)
    print(f'Added document with id {request_artifact.id}')

